//=============================================================================
// Game.h
//=============================================================================
#pragma once
#include <list>

#include "MapManager.h"
#include "Manipulator.h"
#include "PlayerParty.h"
#include "MsgWindow.h"
#include "Effect.h"
#include "Flag.h"

class CDrawable;
class CMapObject;
//-----------------------------------------------------------------------------
// CGame
//-----------------------------------------------------------------------------
class CGame
{
private:
	CGame(void);
	virtual ~CGame(void);

protected:
	int				m_nMode;		// Q[[h
	int				m_nLastMode;	// ÕQ[[h
	int				m_nWaitStatus;	// ҂Ă邩

	// eǗNX
	CMapManager		m_Map;			// n}
	CManipulator	m_Mani;			// 
	CPlayerParty	m_PlayerParty;	// v[
	CMsgWindow		m_wndMsg;		// bZ[WEBhE
	CEffect			m_Effect;		// GtFNg
	CFlag			m_Flag;			// Q[tOǗ

	// \EBhE ǗXg
	std::list<CDrawable *> m_lstDrawObj;

	// }bvؑ֗v
	stMapChangeReqParam		m_MapChangeReqParam;
	// }bvړv
	stMapMoveReqParam		m_MapMoveReqParam;
	// }bvIuWFNgړv
	stMapObjMoveReqParam	m_MapObjMoveReqParam;

	// t[JE^҂v
	int				m_nWaitFrame;

	void FrameMove_ModeMap( void );
	void ChangeDirToPlayer( CMapObject *pMapObj );
	void ChangeMap( stMapChangeReqParam *pPram );
	void MoveMapObject( stMapObjMoveReqParam *pParam );

public:
	static CGame *GetInstance( void );

	BOOL Initialize( void );	// 
	void Finalize( void );		// I

	void FrameMove( void );		// XV
	void Render( void );		// `

	int GetMapID( void ) const
	{	return m_Map.GetID();	};

	// Q[[h
	int GetLastMode( void )	{	return m_nLastMode;	};
	int GetMode( void )		{	return m_nMode;	};

	void SetMode( int nMode )
	{
		if ( m_nMode == nMode )
			return;	// [hȂ牽Ȃ

		m_nLastMode = m_nMode;
		m_nMode		= nMode;
	};
	void SetToPrevMode( void )
	{
		SetMode( m_nLastMode );
	};

	// ҂
	int GetWaitStatus( void )
	{	return m_nWaitStatus;	};

	void SetWaitStatus( int nWaitStatus )
	{	m_nWaitStatus = nWaitStatus;	};

	// }bv}l[WANZbT
	CMapManager *GetMapMan( void )
	{	return &m_Map;	};

	// XNvgJnv
	void StartScriptRequest( CMapObject *pMapObj );

	// ToDo
	void DEBUG_init( void );

	// LuaR[obNp
	void ShowMessage( const char *lpzMessage );
	void CloseMessage( void );
	void AddMessage( const char *lpzMessage );
	void StartFadeout( DWORD dwColor, UINT nFrame );
	void StartFadein( DWORD dwColor, UINT nFrame );
	void ChangeMapRequest( int nMapID, int nLocX, int nLocY, int nPlayerDir );
	char GetTreasureFlag( int nMapID, int nEventID, int *pIndex = NULL );
	void GetTreasure( int nMapID, int nEventID, CItem **pItem );
	void MovePlayer( int nDirection, int nSpeed );
	void MoveMapObject( int nEventID, int nDirection, int nSpeed );
	void WaitFrame( int nFrame );
};
