//=============================================================================
// PlayerParty.cpp
//=============================================================================
#include "Stdinc.h"
#include "PlayerParty.h"
#include "DataManager.h"
#include "Item.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CPlayerParty::CPlayerParty(void)
: m_bIsDash( FALSE )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CPlayerParty::~CPlayerParty(void)
{
	RemoveAllItems();
}
//-----------------------------------------------------------------------------
// RemoveAllItems
//-----------------------------------------------------------------------------
void CPlayerParty::RemoveAllItems( void )
{
	using namespace std;

	list<stItemInfo *>::iterator it = m_lstItemInfo.begin();
	while( it != m_lstItemInfo.end() )
	{
		delete (*it)->pItem;
		(*it)->pItem = NULL;
		delete (*it);
		(*it) = NULL;

		++it;
	}

	m_lstItemInfo.clear();
}

//-----------------------------------------------------------------------------
// GetScrollSpeed
//-----------------------------------------------------------------------------
int CPlayerParty::GetScrollSpeed( void )
{
	if ( m_bIsDash )
		return SCROLL_SPEED_DASH;

	return SCROLL_SPEED_WALK;
}

//-----------------------------------------------------------------------------
// Initialize
//-----------------------------------------------------------------------------
BOOL CPlayerParty::Initialize( void )
{
	// 1l͍
	m_Player[CURRENT_DISP].Create( 1, 1 );

	return TRUE;
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CPlayerParty::FrameMove( const CManipulator *pMani, CMapManager *pMapMan  )
{
	// ݕ\̃L̂ݍXV
	m_Player[CURRENT_DISP].FrameMove( pMani, pMapMan );
}
//-----------------------------------------------------------------------------
// L[`FbNȂXV
//-----------------------------------------------------------------------------
void CPlayerParty::FrameMove( CMapManager *pMapMan  )
{
	// ݕ\̃L̂ݍXV
	m_Player[CURRENT_DISP].FrameMove( pMapMan );
}
//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
void CPlayerParty::Render( void  )
{
	// ݕ\̃L̂ݕ`
	m_Player[CURRENT_DISP].Render();
}
//-----------------------------------------------------------------------------
// AddItem
//-----------------------------------------------------------------------------
int CPlayerParty::AddItem( int nItemID )
{
	// ID̃ACeT
	stItemInfo *pItemInfo = GetItemInfo( nItemID );
	if ( pItemInfo )
	{	// ACe
		pItemInfo->nCount ++;
		// ToDo: MaxItem`FbN
	}
	else
	{	// ACe͂Ȃ

		// VKɏ쐬ăXgɒǉ
		pItemInfo = new stItemInfo;
		pItemInfo->nCount = 1;

		// f[^ǂݍ
		CDataManager::GetInstance()->LoadOneItemData( nItemID, &pItemInfo->pItem );

		m_lstItemInfo.push_back( pItemInfo );
	}

	return m_lstItemInfo.size();
}
//-----------------------------------------------------------------------------
// GetItemInfo
// ItemIDŒT
//-----------------------------------------------------------------------------
stItemInfo *CPlayerParty::GetItemInfo( int nItemID )
{
	using namespace std;

	list<stItemInfo *>::iterator it = m_lstItemInfo.begin();
	while( it != m_lstItemInfo.end() )
	{
		if ( (*it)->pItem->nID == nItemID)
			return (*it);

		++it;
	}
	return NULL;
}

//-----------------------------------------------------------------------------
// RemoveItem
//-----------------------------------------------------------------------------
int CPlayerParty::RemoveItem( int nItemID )
{
	using namespace std;

	list<stItemInfo *>::iterator it = m_lstItemInfo.begin();
	while( it != m_lstItemInfo.end() )
	{
		if ( (*it)->pItem->nID == nItemID)
		{
			if ( 0 < (*it)->nCount )
			{	// 1炷
				(*it)->nCount --;
			}
			else if ( (*it)->nCount == 0 )
			{
				delete (*it)->pItem;
				(*it)->pItem = NULL;
				delete (*it);
				(*it) = NULL;

				m_lstItemInfo.remove( (*it) );

			}

			return m_lstItemInfo.size(); 
		}

		++it;
	}
	return m_lstItemInfo.size();
}
//-----------------------------------------------------------------------------
// GetItemCount
//-----------------------------------------------------------------------------
int CPlayerParty::GetItemCount( int nItemID )
{
	stItemInfo *pInfo = GetItemInfo( nItemID );
	if ( !pInfo )
		return 0;

	return pInfo->nCount;

}
//-----------------------------------------------------------------------------
// GetItemKindCount
//-----------------------------------------------------------------------------
int CPlayerParty::GetItemKindCount( void ) const
{
	return m_lstItemInfo.size();
}
