//=============================================================================
// PlayerParty.cpp
//=============================================================================
#pragma once
#include <list>
#include "PlayerChar.h"

class CManipulator;
class CMapManager;
class CItem;

// ACe
typedef struct {
	CItem	*pItem;	// ACe
	int		nCount;	// 
}stItemInfo;

//-----------------------------------------------------------------------------
// CPlayerParty
//-----------------------------------------------------------------------------
class CPlayerParty
{
protected:
	CPlayerChar		m_Player[PLAYER_COUNT_MAX];	// v[L
	std::list<stItemInfo *> m_lstItemInfo;		// ACe
	UINT			m_nGill;					// M

	// MAPړpo
	int		m_nCurrentDisp;	// ݕ\
	BOOL	m_bIsDash;		// _bVĂ邩
	UINT	m_nAniFrameCnt;	// t[JE^

	void RemoveAllItems( void );

public:
	CPlayerParty(void);
	virtual ~CPlayerParty(void);

	// 
	BOOL Initialize( void );
	// XV
	void FrameMove( const CManipulator *pMani, CMapManager *pMapMan );
	void FrameMove( CMapManager *pMapMan  );

	// `
	void Render( void  );

	int AddItem( int nItemID );
	int RemoveItem( int nItemID );
	int GetItemKindCount( void ) const;
	int GetItemCount( int nItemID );
	stItemInfo *GetItemInfo( int nItemID );

	void SetDirection( int nDirection )
	{	m_Player[CURRENT_DISP].SetDirection( nDirection );	};

	// ݕ\v[L擾
	CPlayerChar *GetDisplayPlayer( void )
	{	return &m_Player[CURRENT_DISP];	};

	// wv[擾
	CPlayerChar *GetPlayer( int nIndex )
	{	return &m_Player[nIndex];	}

	// XN[Xs[h
	int GetScrollSpeed( void );

	// _bVĂ邩
	void SetDash( BOOL bFlag )
	{	m_bIsDash = bFlag;	};
};

